(function () {
    "use strict";

    angular.module('core').controller('campanhaCRMController', controller);
    controller.$inject = ['$scope', '$timeout', 'campanhaCRMService'];

    function controller($scope, $timeout, campanhaCRMService) {
        $scope.initializeLayout('Campanhas do CRM');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    filtro: {
                        Ativo: null,
                        NivelAvalicao: null,
                        NotificacaoPush: { IndicaConsumidoresNotificados: null },
                        Divulgacao: { IndicaRestrita: null }
                    },
                    faixaInicio: { De: null, Ate: null },
                    faixaTermino: { De: null, Ate: null },
                    faixaValorNivel1: { De: null, Ate: null },
                    faixaValorNivel2: { De: null, Ate: null },
                    faixaValorNivel3: { De: null, Ate: null },
                    faixaValorNivel4: { De: null, Ate: null },
                    faixaValorNivel5: { De: null, Ate: null },
                    faixaNotificacao: { De: null, Ate: null },
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            }
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            campanhaCRMService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.count = function () {
            campanhaCRMService
                .count($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.count = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getMore = function () {
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            campanhaCRMService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args.chaves = '';
            $scope.state.filtro.args.filtro.Ativo = null;
            $scope.state.filtro.args.filtro.NivelAvalicao = null;
            $scope.state.filtro.args.filtro.NotificacaoPush.IndicaConsumidoresNotificados = null;
            $scope.state.filtro.args.filtro.Divulgacao.IndicaRestrita = null;
            $scope.state.filtro.args.faixaInicio.De = null;
            $scope.state.filtro.args.faixaInicio.Ate = null;
            $scope.state.filtro.args.faixaTermino.De = null;
            $scope.state.filtro.args.faixaTermino.Ate = null;
            $scope.state.filtro.args.faixaValorNivel1.De = null;
            $scope.state.filtro.args.faixaValorNivel1.Ate = null;
            $scope.state.filtro.args.faixaValorNivel2.De = null;
            $scope.state.filtro.args.faixaValorNivel2.Ate = null;
            $scope.state.filtro.args.faixaValorNivel3.De = null;
            $scope.state.filtro.args.faixaValorNivel3.Ate = null;
            $scope.state.filtro.args.faixaValorNivel4.De = null;
            $scope.state.filtro.args.faixaValorNivel4.Ate = null;
            $scope.state.filtro.args.faixaValorNivel5.De = null;
            $scope.state.filtro.args.faixaValorNivel5.Ate = null;
            $scope.state.filtro.args.faixaNotificacao.De = null;
            $scope.state.filtro.args.faixaNotificacao.Ate = null;

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();